/* ̧قDoxygenpɏĂ܂B*/
/*! \file ********************************************************************
 *
 * \brief
 *		1-Wire(R)޽ʐMp֐
 *
 *		1-Wire(R)޽ł̊S޲Ă̑MROM߂̎̂߂̍ʊ֐\n
 *		1-Wire(R)Kɉ{IޯĒiKł̐M̎߰ݸ ĳ\n
 *		ްQCRC8CRC16A64ޯROMʎq̌܂݂܂B
 *		x޲: SAVR
 *
 * \par pLq:
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *		uAVR318 - Dallas 1-Wire(R)呕uvɊPK
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com \n
 *		Original author: \n
 *
 * $Name$
 * $Revision: 2299 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr463_Charging_NiMH_Batteries_with_BC100/tags/20070904_release_code_1.0/code/IAR/OWI.c $
 * $Date: 2007-08-23 12:55:51 +0200 (to, 23 aug 2007) $\n
****************************************************************************/

#include <ioavr.h>
#include <inavr.h>

#include "OWI.h"

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief 1-Wire޽(ĳ̂ݔ)
 *
 * ̊֐1-Wire޽J邱ƂɂĂAݐM()I
 * ܂ő҂܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_Init(unsigned char pins){
	OWI_RELEASE_BUS(pins);					// 1-Wire޽J(Hi-Z)
	__delay_cycles(OWI_DELAY_H_STD_MODE);	// ݐMԕҋ@
	// ㏸[͏]uɂؾĐM̏IƂĉ߂꓾܂BۂؾĐM
	// ߂̂ۏ؂邽߂ɁAKvؾĐM񕜎(H)Ax
	// ܂B
}

/*! \brief ޽ւ'1'(ĳ̂ݔ)
 *
 * 1-Wire޽'1'ޯđMpg`𐶐܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_WriteBit1(unsigned char pins){
	unsigned char intState;

	intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
	__disable_interrupt();					// S̊荞݋֎~
	OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
	__delay_cycles(OWI_DELAY_A_STD_MODE);	// 1LԎԑҋ@
	OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
	__delay_cycles(OWI_DELAY_B_STD_MODE);	// 1ݎcԑҋ@
	__restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
}

/*! \brief ޽ւ'0'(ĳ̂ݔ)
 *
 * 1-Wire޽'0'ޯđMpg`𐶐܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_WriteBit0(unsigned char pins)
{
	unsigned char intState;

	intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
	__disable_interrupt();					// S̊荞݋֎~
	OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
	__delay_cycles(OWI_DELAY_C_STD_MODE);	// 0LԎԑҋ@
	OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
	__delay_cycles(OWI_DELAY_D_STD_MODE);	// 0ݎcԑҋ@
	__restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
}

/*! \brief ޽ޯēǂݍ(ĳ̂ݔ)
 *
 * 1-Wire޽ޯĎMpg`𐶐܂B
 *
 *  \param  pins	ǂݍ޽ޯĎՕl
 *
 *  \return			'1'ǂ܂ꂽ޽ޯĎՕl
 */
unsigned char OWI_ReadBit(unsigned char pins)
{
	unsigned char intState;
	unsigned char bitsRead;

	intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
	__disable_interrupt();					// S̊荞݋֎~
	OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
	__delay_cycles(OWI_DELAY_A_STD_MODE);	// ǂݍLԎԑҋ@
	OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
	__delay_cycles(OWI_DELAY_E_STD_MODE);	// ̎xҋ@
	bitsRead = OWI_PIN & pins;				// Ή޽Ԓl擾
	__delay_cycles(OWI_DELAY_F_STD_MODE);	// ǂݍݎcԑҋ@
	__restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
	return bitsRead;						// Ή޽擾ޯĒlƋɕA
}

/*! \brief ؾĐMoƑݐM(ĳ̂ݔ)
 *
 * 1-Wire޽ؾđMpg`𐶐AݐM𒮎悵܂B
 *
 *  \param  pins	ؾĐM𑗏o޽ޯĎՕl
 *
 *  \return			ݐMoꂽ޽ޯĎՕl
 */
unsigned char OWI_DetectPresence(unsigned char pins)
{
	unsigned char intState;
	unsigned char presenceDetected;

	intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
	__disable_interrupt();					// S̊荞݋֎~
	OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
	__delay_cycles(OWI_DELAY_H_STD_MODE);	// ؾĐMLԎԑҋ@
	OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
	__delay_cycles(OWI_DELAY_I_STD_MODE);	// ̎xҋ@
	presenceDetected = ((~OWI_PIN) & pins);	// Ή޽ݐMl擾
	__delay_cycles(OWI_DELAY_J_STD_MODE);	// ݐMcԑҋ@
	__restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
	return presenceDetected;				// Ή޽ݐMlƋɕA
}

/*! \brief 1-Wire(R)޽1޲Ăް𑗐M
 *
 * ̊֐1-Wire޽ɊS޲ ް𑗐MƂ܂B
 *
 *  \param  data	޽ɑMް
 *  
 *  \param  pins	ް𑗐M޽ޯĎՕl
 */
void OWI_SendByte(unsigned char data, unsigned char pins)
{
	unsigned char temp;
	unsigned char i;

	for (i = 0; i < 8; i++) {		// 1޲(8ޯ)M
		temp = data & 0x01;			// ΉޯĒlo
		if (temp) {					// Ήޯ=1ŁA
			OWI_WriteBit1(pins);	// 1ޯđM
		} else {					// Ήޯ=0ŁA
			OWI_WriteBit0(pins);	// 0ޯđM
		}
		data >>= 1;					// MlE1ޯĈړ
	}
}

/*! \brief 1-Wire(R)޽1޲ĎM
 *
 * ̊֐1-Wire޽犮S1޲ ް̎M܂B
 *
 *  \param  pin	ǂݍ޽ޯĎՕl
 *
 *  \return		޽ǂ܂ꂽ޲Ēl
 */
unsigned char OWI_ReceiveByte(unsigned char pin)
{
	unsigned char data;
	unsigned char i;

	data = 0x00;					// Mlϐ
	for (i = 0; i < 8; i++) {		// 1޲(8ޯ)M
		data >>= 1;					// MlϐE1ޯĈړ,0MSB
		if (OWI_ReadBit(pin)) {		// ǂݍݐMo/ǂݍ=1ŁA
			data |= 0x80;			// MlϐMSB=1
		}
	}
	return data;					// M޲ĒlƋɕA
}

/*! \brief 1-WireSKIP ROMߑo
 *
 *  \param  pins	SKIP ROM߂𑗏o޽ޯĎՕl
 */
void OWI_SkipRom(unsigned char pins)
{
	OWI_SendByte(OWI_ROM_SKIP, pins);	// SKIP ROMߑM
}

/*! \brief READ ROMߑoROMʎqǂݖ߂
 *
 *  \param  romValue	ʎqzuꏊւ߲
 *
 *  \param  pin			ǂݍ޽̎Օl
 */
void OWI_ReadRom(unsigned char * romValue, unsigned char pin)
{
	unsigned char bytesLeft = 8;

	OWI_SendByte(OWI_ROM_READ, pin);		// READ ROMߑM
	while (bytesLeft > 0) {					// 64ޯ(8޲)M
		*romValue++ = OWI_ReceiveByte(pin);	// ΉM޲Ăwʒu,߲is
		bytesLeft--;						// ޲Čv팸
	}
}

/*! \brief MATCH ROM߂Ǝw莯ʎqo
 *
 *  \param  romValue	w莯ʎqւ߲
 *
 *  \param  pins		MATCH ROM߂s޽̎Օl
 */
void OWI_MatchRom(unsigned char * romValue, unsigned char pins)
{
	unsigned char bytesLeft = 8;

	OWI_SendByte(OWI_ROM_MATCH, pins);		// MATCH ROMߑM
	while (bytesLeft > 0) {					// 64ޯĎʎq(8޲)M
		OWI_SendByte(*romValue++, pins);	// w莯ʎqΉ޲đM,߲is
		bytesLeft--;						// ޲Čv팸
	}
}

/*! \brief SEARCH ROM߂𑗏o1-Wire(R)޽œ1̎ʎqԂ
 *
 *  \param  bitPattern		ʎqu8޲charzւ߲B
 *							̏]uɑ΂錟AŌɓꂽʎq
 *							zɒ񋟂ׂAȂΌ
 *							s܂B
 *
 *  \param  lastDeviation	ȎsɉĐisޯĈʒuB
 *							̈͌Jn0łׂłBJԂČ
 *							Ԏɂ̊֐̈ɕԂl邱ƂS
 *							]us܂B
 *
 *  \param  pin				ʎqs޽ޯĎՕl
 *
 *  \return					̊֐̒Osŏ]uڽԂŕsv
 *							IޯĈʒuB
 *							ُ팟o(ႦΌ̍Œɑuڑꂽ)OWI
 *							_ROM_SEARCH_FAILEDAׂuȂ
 *							OWI_ROM_SEARCH_FINISHEDԂ܂B
 *
 *  \note					̊֐̗p@ɂĂmain.cB
 */
unsigned char OWI_SearchRom(unsigned char * bitPattern, unsigned char lastDeviation, unsigned char pin)
{
	unsigned char currentBit = 1;
	unsigned char newDeviation = 0;
	unsigned char bitMask = 0x01;
	unsigned char bitA;
	unsigned char bitB;

	OWI_SendByte(OWI_ROM_SEARCH, pin);				// SEARCH ROMߑM
	while (currentBit <= 64) {						// 64ޯĎʎq擾
		bitA = OWI_ReadBit(pin);					// ΉޯĒlM
		bitB = OWI_ReadBit(pin);					// ΉޯĔ]lM
		if (bitA && bitB) {							// '11'ŁA
			newDeviation = OWI_ROM_SEARCH_FAILED;	// sԂlݒ
			return newDeviation;					// sƋɕA
		} else if (bitA ^ bitB) {					// '01'܂'10'ŁA
			if (bitA) {								// Ήޯ=1ŁA
				(*bitPattern) |= bitMask;			// MʎqΉޯ=1ݒ
			} else {								// Ήޯ0ŁA
				(*bitPattern) &= ~bitMask;			// MʎqΉޯ=0ݒ
			}
		} else {									// '00'ŁA
			if (currentBit == lastDeviation) {		// OƓޯĈʒuŁA
				(*bitPattern) |= bitMask;			// MʎqΉޯ=1ݒ(O0oς݂Ȃ̂)
			}
			else if (currentBit > lastDeviation) {	// OޯĈʒuȍ~ŁA
				(*bitPattern) &= ~bitMask;			// MʎqΉޯ=0ݒ
				newDeviation = currentBit;			// ޯĈʒuԍXV
			}
			else if ( !(*bitPattern & bitMask)) {	// 0ς݂ŁA
				newDeviation = currentBit;			// ޯĈʒuԍXV
			}
			else {									// 1ς݂ŁA
			}
		}
		if ((*bitPattern) & bitMask) {				// 񔻒ޯ=1ŁA
			OWI_WriteBit1(pin);						// FޯĂƂāA1ݐMM
		} else {									// 񔻒ޯ=0ŁA
			OWI_WriteBit0(pin);						// FޯĂƂāA0ݐMM
		}
		currentBit++;								// ޯĔԍis
		bitMask <<= 1;								// ޯĎՕl1ޯĈړ
		if (!bitMask) {								// 1޲ďIŁA
			bitMask = 0x01;							// ޲ēޯĎՕl擾
			bitPattern++;							// Mʎq߲is
		}
	}
	return newDeviation;							// ޯĈʒuƋɕA
}

/* CRCp֐ */
/*! \brief ްQCRC8lvZ
 *
 * ̊֐CRCɑ΂鏉lƂseedgpinDataCRC8܂DOW-CRCv
 * Z܂B
 *
 *  \param  inData	CRCvZް1޲
 *
 *  \param  seed	CRC̊Jnl
 *
 *  \return	lƂĂseedłinDataCRC8
 *
 *  \note	seed0ݒinDatacrc8()vZ܂B
 *
 *  \note	seedƂĂ̊֐̕ԂlpIɓnƂްCRC8
 *			lvZ܂B
 */
unsigned char OWI_ComputeCRC8(unsigned char inData, unsigned char seed)
{
	unsigned char bitsLeft;
	unsigned char temp;

	for (bitsLeft = 8; bitsLeft > 0; bitsLeft--) {
		temp = ((seed ^ inData) & 0x01);	// Ήޯ(LSB)_
		if (temp == 0) {					// Ήޯ=0
		seed >>= 1;							// E1ޯĈړ
		} else {							// Ήޯ=1
			seed ^= 0x18;					// X5,X4XOR
			seed >>= 1;						// E1ޯĈړ
			seed |= 0x80;					// X8XOR
		}
		inData >>= 1;						// E1ޯĈړ
	}
	return seed;							// ݂CRCƋɕA
}

/*! \brief ްQCRC16lvZ
 *
 * ̊֐CRCɑ΂鏉lƂseedgpinDataCRC16vZ܂B
 *
 *  \param  inData	CRCvZް1޲
 *
 *  \param  seed	CRC̊Jnl
 *
 *  \return	lƂĂseedłinDataCRC16
 *
 *  \note	seed0ݒinDatacrc16()vZ܂B
 *
 *  \note	seedƂĂ̊֐̕ԂlpIɓnƂްCRC16
 *			lvZ܂B
 */
unsigned int OWI_ComputeCRC16(unsigned char inData, unsigned int seed)
{
	unsigned char bitsLeft;
	unsigned char temp;

	for (bitsLeft = 8; bitsLeft > 0; bitsLeft--) {
		temp = ((seed ^ inData) & 0x01);	// Ήޯ(LSB)_
		if (temp == 0) {					// Ήޯ=0
			seed >>= 1;						// E1ޯĈړ
		} else {							// Ήޯ=1
			seed ^= 0x4002;					// X15,X2XOR
			seed >>= 1;						// E1ޯĈړ
			seed |= 0x8000;					// X16XOR
		}
		inData >>= 1;						// E1ޯĈړ
	}
	return seed;							// ݂CRCƋɕA
}

/*! \brief 64ޯROMʎqCRCvZƌ
 *
 * ̊֐64ޯĎʎq̐擪56ޯĂCRC8lvZ܂BROMɊi[
 * ĂCRClɑ΂ČvZl܂B
 *
 *  \param  romvalue	64ޯĎʎqێĂzւ߲
 *
 *  \retval OWI_CRC_OK		CRCv
 *  \retval OWI_CRC_ERROR	i[ĂCRCƌvZCRCԂɕsv
 */
unsigned char OWI_CheckRomCRC(unsigned char *romValue)
{
	unsigned char i;
	unsigned char crc8 = 0;

	for (i = 0; i < 7; i++) {						// 56ޯ(7޲)CRCvZ
		crc8 = OWI_ComputeCRC8(*romValue, crc8);	// Ή޲CRCvZ
		romValue++;									// ߲is
	}
	if (crc8 == (*romValue)) {						// MCRCƌvZCRCr
		return OWI_CRC_OK;							// vňvlƋɕA
	}
	return OWI_CRC_ERROR;							// svŕsvlƋɕA
}
